Try adding a sleep between cdrecord and verify
[backups/.git] / scripts / burn-imgs.sh
index 0e1a6bfa139368d2b92dd3c7ca88efbba4517d29..5d030bf5f46918d09b5975e2abe8eaf844600531 100755 (executable)
@@ -1,43 +1,56 @@
 #!/bin/sh
 
-PATH=$(dirname $0):/bin:/usr/bin
+export PATH=$(dirname $0):/bin:/usr/bin:/sbin
 
+cronstopstart="/etc/init.d/cron"
 . config.sh
 
 # If the noburn file is there then don't burn.
 [ -f "$noburnfile" ] && exit 0
-touch $noburnfile
 
 # Discover disk images by looking for .img.md5sum files in $imagedir
-imgmd5=$(ls $imagedir/*.img.md5sum | head -n 1)
-
-logfile=$(tempfile)
+imgmd5=$(ls $imagedir/*.img.md5sum 2>/dev/null | head -n 1)
 
 # If we didn't find an non-empty file then exit gracefully
 [ -z "$imgmd5" ] && exit 0
 [ -s "$imgmd5" ] || exit 0
 
+logfile=$(tempfile)
+
 # Get the name of the disk image by stripping off the tailing '.md5sum'
 img=${imgmd5%.md5sum}
 
+touch $noburnfile
+
 # A little paranoia.  Make sure the disk image file is there.
 [ -z "$img" ] && exit 1
 [ -s "$img" ] || exit 1
 
+# To avoid buffer underruns I'm going to stop cron and renice myself
+$cronstopstart stop
+renice -10 $$
+
 # Burn the image to a disk.
-cdrecord-wrapper.sh -dao dev=$sdev $isoimage > $logfile 2>&1
+cdrecord-wrapper.sh -dao dev=$sdev $img > $logfile 2>&1
 
 if [ "0" != "$?" ]; then
   echo >&2 "cdrecord failed!"
   exit 1
 fi
 
+# We don't need to be high-priority anymore.
+renice 0 $$
+$cronstopstart start
+
+# I don't know if this *really* helps but give cdrecord a chance to clean up.
+sleep 60
+
 # Now verify the disk by running md5sum on the entire contents of the disk
 md5sum=$(tempfile)
-dd if=$dev bs=1M count=4440 2>$logfile | md5sum | awk '{print$1}' > $md5sum
+dd if=$dev bs=1M count=4440 2>>$logfile | md5sum | awk '{print$1}' > $md5sum
 
 # Check that the md5sums match
-if ! cmp $md5sum $isoimage.md5sum; then
+if ! cmp $md5sum $img.md5sum; then
   echo "Failed" | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
   exit 1
 fi
@@ -50,13 +63,15 @@ date >> $img.stat
   cat $img.md5sum
   echo
   echo "md5sum of burned disks:"
+  cat $md5sum
+  echo
   cat $img.stat
   echo
   cat $logfile
-} | mailx -s "DVD burned.  File as ${img%.*}" $mailto > $logfile 2>&1
+} | mailx -s "DVD burned.  File as $(basename ${img%.*})" $mailto > $logfile 2>&1
 
 # Two lines in the stat file indicate two successful burns.  Clean-up the image.
-if [ "$(wc -l $img.stat 2>/dev/null)" == "2" ]; then
+if [ "$(wc -l $img.stat 2>/dev/null | awk '{print$1}')" == "2" ]; then
   # Burned the image twice.  Removing it and associated files!
   rm -f $img{,.md5sum,.stat}
   [ -d $img.mnt ] && rmdir $img.mnt